<?php // -*- coding: utf-8-unix -*-
/*
 * $Id: backend.php,v 1.2 2005/10/05 12:19:48 noir Exp $
 * Copyright (C) 2005 Hiroyuki KUROSAKI <noir[at]st.rim.or.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

$registered_functions = array();

function register_request_function($short_name, $full_name) {
    global $registered_functions;
    $registered_functions[$short_name] = $full_name;
}

function is_valid_request($short_name) {
    global $registered_functions;
    return array_key_exists($short_name, $registered_functions);
}

function dispatch_request($short_name, $opts) {
    global $registered_functions;
    return call_user_func_array($registered_functions[$short_name], $opts);
}

function send_gengo_table($opts) {
    require_once('./lib/JSON.php');
    include('./gengo_table.php');
    $json = new JSON();
    print($json->encode($gengo_table));
}

function respond($request) {
    $functions = array('tbl' => 'send_gengo_table');

    foreach ($functions as $sn => $fn) {
        register_request_function($sn, $fn);
    }

    if (isset($_REQUEST['f']) && is_valid_request($_REQUEST['f'])) {
        dispatch_request($_REQUEST['f'], $_REQUEST);
    }
    else {
        echo "Error: invalid request." . $_SERVER['QUERY_STRING'];
    }
}

respond($_REQUEST);
?>
